
#define MAXLINE				4096	/*	ő僉C	*/

#define FLAT_SHADE		1
#define GOURAUD_SHADE	2

#define	SHADE_SHIFT		22		/*  VF[fBÕVtg			*/
#define	SHADE_POINT		(4*1024*1024)
								/*  VF[fBȌ_ʒu			*/

#ifdef FULLCOLOR
	typedef unsigned long	ColorCode ;
#else
	typedef unsigned short	ColorCode ;
#endif

/*	fW^p̍\	*/
typedef struct	_DDA {
		short	x ;			/*	݂̂W		*/
		short	totalmod ;	/*	]̍v			*/
		short	dxdy ;		/*	W̐	*/
		short	mod ;		/*	]				*/
		short	dy ;		/*					*/
		short	dx ;		/*	̕ωl			*/
	}
		DDA ;

/*	}bsOf[^	*/
typedef struct	_Map {
#ifdef WINDOWS
		int h, v, fullcolor;
#else
#ifdef FULLCOLOR
		int         h:16, v:15, fullcolor:1;
#else
		short		h, v ;
#endif
#endif
#ifdef REFMAP
		short		wh, wv;
#endif
		Pointer(ColorCode*)		*buf ;
		Pointer(Atr*)		atr ;
	}
		Map ;

/*	X[XVF[fBÕf[^	*/
typedef struct	_ShadeTable {
		Color	curcolor ;
		Color	stepcolor ;
#ifdef SPEC
		Color	curspecular ;
		Color	stepspecular ;

		Color	depthcolor;
		long	depthrate;
		long	stepdepthrate;
#endif
#ifdef REFMAP
		Color	refcolor;
		long currefdir[3];			/*direction vector, normalize SHADE_SHIFT*/
		long steprefdir[3];
#endif
	}
		ShadeTable ;

/*  }bsOf[^  */
typedef	struct	_MapTable {
		long	curuv[2] ;
		long	stepuv[2] ;
		long	stepstepuv[2];
		Map		*map ;
	}
		MapTable ;

/*@Agr[gf[^  */
typedef	struct	_AtrTable {
		ShadeTable	shade ;
		MapTable	map ;
	}
		AtrTable ;

/*	GbWXg	*/
typedef struct	_EdgeList {
		short		n ;			/*	cĂ郉C		*/
		DDA			dxdy ;		/*	̌X				*/
		long		z ;			/*	̐̃fBvXl		*/
		long		dzdy ;		/*	y̐̔W		*/
		int			polyid ;	/*	ӂ̑|S		*/
		char		flag ;		/*  tO					*/
		ColorCode	code ;		/*	J[R[h			*/
		char		traflag ;	/*	tO			*/
		unsigned char	tra[3];	/*						*/
		char		mapflag ;	/*  }bsOtO		*/
		Pointer(struct _EdgeList*)		next ;		/*	ւ̃|C^			*/
		ShadeTable	shade ;		/*	VF[fBOf[^	*/
		MapTable	map ;		/*  }bsOf[^		*/
	}
		EdgeList ;

#ifndef GLIB
	extern	int			XPixel, YPixel ;		/*	sNZ				*/
	extern	Float		PixelRatio ;			/*	sNZ̏c		*/
	extern	Float		FrontClip ;				/*	OʃNbsO	*/
	extern	Pointer(EdgeList*)		EdgeBuf[MAXLINE] ;		/*	GbWXg̃obt@	*/
	extern	int			TraBack ;				/*	obN̓IvV	*/
	extern	int			BackLoad ;				/*  wiǂݍ݃IvV  */
	extern	char		BackFile[F_NAME_LEN] ;	/*  wit@C			*/
	extern	int			ShadingModel ;			/*	VF[fBOf	*/
	extern	void		(*PictureOutput)(ColorCode*) ;	/*	摜o͊֐			*/
	extern	void		(*LineOutput)(int,int,int,int) ;		/*	Co͊֐			*/
	#ifdef	XC
		extern	int		BackGroundJob ;			/*	obNOEhWu	*/
	#endif
	#ifdef	REFMAP
		extern int		RefMap;					/*	}bsO			*/
		extern char		RefMapFile[6][F_NAME_LEN];
												/*	}bsOt@C			*/
		extern Map		*RefMapData[6];
	#endif
	#ifdef	BGMAKE
		extern int		BgMake;
		extern char		BgMakeFile[12][F_NAME_LEN];
		extern Map		*BgMakeData[12];
		extern Atr		*BgMakeAtr[12];
	#endif
#endif

/*
	proto -e -f glib.c viewconv.c edgelist.c color.c > temp
	proto -e -f display.c map.c back.c >> temp
*/

/*  glib.c  */
extern	int		checkbuserror( void* );

/*  viewconv.c  */
extern	long		ViewConv( Frame* );

/*  edgelist.c  */
extern	void	InitEdgeList( void );
extern	void	SetEdgeList( Point*, AtrTable*, int, Pointer(Atr*) );

/*  color.c  */
extern	int	GetAtrTable( AtrTable*, Frame*, Poly*, Matrix, Matrix );
extern	const	ColorCode	ColorToCode( Color );
extern	ColorCode	GetColorCode( ShadeTable*, MapTable* );
#ifdef SPEC
extern	ColorCode	GetColorAllCode( ShadeTable*, MapTable* );
extern	ColorCode	GetSpecularColorCode( ShadeTable* );
#endif
extern	void	ColorToShadeTable( ShadeTable*, Color );
extern	void	ColorToShadeDepthTable( ShadeTable*, Color );
extern	void	ColorToShadeSpecularTable( ShadeTable*, Color );
extern	void	IncAtrTable( ShadeTable*, MapTable* );
extern	void	AddAtrTable( ShadeTable*, MapTable*, int );
extern	void	SetAtrStep( ShadeTable*, ShadeTable*, MapTable*, MapTable*, int );
#ifdef EXTENDMAP
extern	void	SetAtrStepMap( long, long, MapTable*, MapTable*, int );
#endif
#ifdef FULLCOLOR
extern	ColorCode X68kcolorToColorCode( unsigned short );
#endif

/*  display.c  */
extern	void	Display( Frame*, int );

/*  map.c  */
extern	int		MapInit( Pointer(Atr*) );
extern	void	SetMapTable( AtrTable*, Pointer(Point*), int, Pointer(Atr*) );
extern	unsigned short 	getshort( FILE* );
extern	unsigned long	getlong( FILE* );

/*  back.c  */
extern	void	BackOpen( char* );
extern	void	BackCopy( ColorCode* );
extern	void	BackClose( void );

/*	star.c	*/
extern void StarInit(int stars, int dir, int step);
extern void	StarStep(void);
extern void Star(int stars, Matrix view, Float dist);
extern void StarCopy(ColorCode *buf);

